#include "BoostPreprocessorThread.h"
#include "Camera.h"
#include "KdTree.h"
#include "SceneGraph.h"
#include "Preprocessor.h"

// ??????????????? commented by VH ????????????
//#include <boost/thread/thread.hpp>

namespace GtpVisibilityPreprocessor {


#ifdef THREADS1
  
BoostPreprocessorThread::BoostPreprocessorThread(Preprocessor *p):
PreprocessorThread(p), mThread(NULL)
{
}


void BoostPreprocessorThread::operator()()
{
	Main();
}




BoostPreprocessorThread::~BoostPreprocessorThread()
{
  cerr << "Boost Preprocessor thread destructor ... \n";
  DEL_PTR(mThread);
}


void BoostPreprocessorThread::InitThread()
{
  mThread = new boost::thread(*this);
  
  PreprocessorThread::InitThread();
}

int
BoostPreprocessorThread::GetCurrentThreadId() const
{
  // $$ temporary implementation
  return 0;
}


void BoostPreprocessorThread::RunThread()
{
	Main();
  //mThread->join();
}

#endif // THREADS1

  
}
